package io.zipcoder;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;


public class WC {
    private Iterator<String> si;
    private Map<String, Integer> theCount = new HashMap<>();

    public WC(String fileName) {
        try {
            Scanner scan = new Scanner(new FileReader(fileName));
            scan.useDelimiter("[\\p{Punct}\\s]+");
            this.si = scan;
        } catch (FileNotFoundException e) {
            System.out.println(fileName + " Does Not Exist");
            System.exit(-1);
        }
    }

    public WC(Iterator<String> si) {
        this.si = si;

    }

    public void wordCount() {
        while(si.hasNext()) {
            String words = si.next().toLowerCase();
            if (theCount.containsKey(words)){
                Integer counter = theCount.get(words);
                theCount.put(words, (counter +1));
            } else {
                theCount.put(words, 1);
            }

        }
        theCount.entrySet()
                .stream()
                .sorted(Map.Entry.<String, Integer>comparingByValue().reversed())
                .forEach(System.out::println);

    }

    public static void main(String[] args) {
        String file = "./../../MachenArthur.txt";
        String path =  WC.class.getResource("/MachenArthur.txt").getFile();
        WC wc = new WC(path);
        wc.wordCount();

    }

}



