package io.zipcoder;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class ParenCheckerTest {




    @Test
    public void matchingCharactersTest() {
        //Given
        char char1 = '<';
        char char2 = '>';

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.matchingCharacters(char1, char2);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void matchingCharactersTest02() {
        //Given
        char char1 = '[';
        char char2 = '}';

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.matchingCharacters(char1, char2);

        //Then
        Assert.assertFalse(actual);
    }

    @Test
    public void balancedCharactersTest01() {
        //Given
        String testString = "()";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void balancedCharactersTest02() {
        //Given
        String testString = "(){}[]<>";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void balancedCharactersTest03() {
        //Given
        String testString = "({[<>]})";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void balancedCharactersTest04() {
        //Given
        String testString = "([<]{})>";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void balancedCharactersTest05() {
        //Given
        String testString = "({[<>})";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertFalse(actual);
    }

    @Test
    public void balancedCharactersTest06() {
        //Given
        String testString = "({[})]";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }
    @Test
    public void balancedCharactersTest07() {
        //Given
        String testString = "(\'{[})\']";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertTrue(actual);
    }

    @Test
    public void balancedCharactersTest08() {
        //Given
        String testString = "(\"{[})]";

        //When
        ParenChecker checker = new ParenChecker();
        boolean actual = checker.completeCheck(testString);

        //Then
        Assert.assertFalse(actual);
    }



}